Home My Page Projects Code Snippets Project Openings SML/NJ
Summary Activity Forums Tracker Lists Tasks Docs Surveys News SCM Files

SCM Repository

[smlnj] Diff of /config/trunk/install.sh
ViewVC logotype

Diff of /config/trunk/install.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 573, Thu Mar 9 15:23:52 2000 UTC revision 1873, Sun Nov 20 05:32:27 2005 UTC
# Line 1  Line 1 
1  #!/bin/sh  #!/bin/sh
2  #  #
3  # Copyright (c) 1994 AT&T Bell Laboratories.  # Copyright (c) 1994 AT&T Bell Laboratories.
4    # Copyright (c) 2003 The Fellowship of SML/NJ
5  #  #
6  # Installation script for SML/NJ and related tools; this is a temporary  # Installation script for SML/NJ and related tools; this is a temporary
7  # placeholder until the configuration tool is finished.  # placeholder until the configuration tool is finished.
8  #  #
9  # Significant changes to accommodate (and take advantage of) the new CM  # Significant changes to take advantage of a new portable installer
10  # by M.Blume (2/2000).  # script for everything after booting the interactive system.
11  #  #
12    # Author: Matthias Blume (blume@tti-c.org)
 #  
 # get the target list  
13  #  #
14  if [ ! -r config/targets ]; then  
15      echo "!!! File config/targets is missing."  if [ x$1 = xnolib ] ; then
16      exit 1      nolib=true
17    else
18        nolib=false
19    fi
20    
21    if [ x${INSTALL_QUIETLY} = xtrue ] ; then
22        export CM_VERBOSE
23        CM_VERBOSE=false
24    fi
25    
26    vsay() {
27        if [ x${INSTALL_DEBUG} = xtrue ] ; then
28            echo "$@"
29        elif [ x${INSTALL_QUIETLY} = xtrue ] ; then
30            :
31        else
32            echo "$@"
33  fi  fi
34  . config/targets  }
35    
36    complain() {
37        echo "$@"
38        exit 1
39    }
40    
41    this=$0
42    
43    
44  #  #
45  # create the preloads.standard file  # create the preloads.standard file
46  #  #
47  if [ ! -r config/preloads ]; then  if [ ! -r config/preloads ]; then
48      echo "!!! File config/preloads is missing."      complain "$this: !!! File config/preloads is missing."
     exit 1  
49  fi  fi
50  cp config/preloads preloads.standard  cp config/preloads preloads.standard
51    
# Line 34  Line 56 
56  MAKE=make  MAKE=make
57    
58  SHELL=/bin/sh  SHELL=/bin/sh
59  echo Using shell $SHELL.  vsay $this: Using shell $SHELL.
60    
61  #  #
62  # set the SML root directory  # set the SML root directory
63  #  #
64  REAL_PWD=`pwd`  REAL_PWD=`pwd`
65  ROOT=${PWD:-$REAL_PWD}  ROOT=${PWD:-$REAL_PWD}
66  echo SML root is $ROOT.  vsay $this: SML root is $ROOT.
67  echo Installation directory is ${INSTALLDIR:=$ROOT}.  
68    cd "${INSTALLDIR:=$ROOT}"
69    INSTALLDIR=`pwd`
70    cd "$ROOT"
71    vsay $this: Installation directory is ${INSTALLDIR}.
72    
73  #  #
74  # set the various directory and file pathname variables  # set the various directory and file pathname variables
# Line 53  Line 79 
79  RUNDIR=$BINDIR/.run             # where executables (i.e., the RTS) live  RUNDIR=$BINDIR/.run             # where executables (i.e., the RTS) live
80  SRCDIR=$ROOT/src                # where the source tree is rooted  SRCDIR=$ROOT/src                # where the source tree is rooted
81  LIBDIR=$INSTALLDIR/lib          # where libraries live  LIBDIR=$INSTALLDIR/lib          # where libraries live
 LIBLIST=$ROOT/liblist           # list of commands to stabilize libraries  
 LIBMOVESCRIPT=$ROOT/libmove     # a temporary script  
 LOCALPATHCONFIG=$INSTALLDIR/pathconfig # a temporary pathconfig file  
   
 URLGETTER=unknown  
   
 #  
 # the path to the dir where ml-yacc, ml-burg, ml-lex, and ml-build live  
 #  
 TOOLDIR=$BINDIR  
82    
83  #  #
84  # files to be deleted after we are done...  # files to be deleted after we are done...
85  #  #
86  tmpfiles=""  tmpfiles=""
87  tmpfiles="$tmpfiles $ROOT/preloads.standard"  tmpfiles="$tmpfiles preloads.standard"
 tmpfiles="$tmpfiles $LIBLIST"  
 tmpfiles="$tmpfiles $LOCALPATHCONFIG"  
 tmpfiles="$tmpfiles $LIBMOVESCRIPT"  
88  #  #
89  # make sure we always clean up after ourselves...  # make sure we always clean up after ourselves...
90  #  #
91  trap 'rm -f $tmpfiles' 0 1 2 3 15  trap 'cd "$ROOT"; rm -f $tmpfiles' 0 1 2 3 15
92    
93    
94  #  #
95  # set the CM configuration variables (these are environment variables  # set the CM configuration variables (these are environment variables
96  # that will be queried by the bootstrap code)  # that will be queried by the bootstrap code)
97  # Especially important is CM_PATHCONFIG_DEFAULT.  # Especially important is CM_PATHCONFIG.
98  #  #
99  CM_PATHCONFIG_DEFAULT=$LIBDIR/pathconfig  export CM_PATHCONFIG
100  export CM_PATHCONFIG_DEFAULT  CM_PATHCONFIG=$LIBDIR/pathconfig
   
101  #  #
102  # the release version that we are installing  # the release version that we are installing
103  #  #
104  VERSION=`cat $CONFIGDIR/version`  VERSION=`cat "$CONFIGDIR/version"`
105  echo Installing version $VERSION.  vsay $this: Installing version $VERSION.
106    
107  #  #
108  # the URL for the (usually remote) source archive  # the URL for the (usually remote) source archive
109  #  #
110  SRCARCHIVEURL=`cat $CONFIGDIR/srcarchiveurl`  . "$CONFIGDIR"/srcarchiveurl
111  echo URL of source archive is $SRCARCHIVEURL.  vsay $this: URL of source archive is $SRCARCHIVEURL.
112    
113  #  #
114  # Function to make a directory (and advertise such action).  # Function to make a directory including its ancestors.
115  #  #
116  makedir() {  makedir() {
117      if [ ! -d $1 ] ; then      if [ x"$1" = x ] ; then
118          echo Making directory $1          :
119          if mkdir $1 ; then      elif [ -d "$1" ] ; then
120              : everything is fine          :
121          else          else
122              echo "!!! Unable to make directory $1!"          makedirtmp=`dirname "$1"`
123              exit 1          makedir "$makedirtmp"
124            if [ x${INSTALL_VERBOSE} = xtrue ] ; then
125                vsay "$this: Making directory $1"
126            fi
127            if mkdir "$1" ; then
128                :
129            else
130                complain "$this: !!! Unable to make directory $1!"
131          fi          fi
132      fi      fi
133  }  }
134    
135  #  #
136  # Function for asking user to fetch source archive.  # Fish out the CM metadata directory name from library files
137  #   $1 - descriptive name  # and store it in ORIG_CM_DIR_ARC.
138  #   $2 - base name without extension, without version, and without dir  # The single argument is the name of the directory containing
139  #   $3 - remote directory  # a single subdirectory which is a CM metadata directory:
 #  
 askurl() {  
     echo Please, fetch $1 archive '('$VERSION-$2.'*)' from  
     echo '  ' $3  
     echo "and then re-run this script!"  
     exit 1  
 }  
   
140  #  #
141  # Function for fetching source archives automatically using wget or lynx.  fish() {
142  #   $1 - command to actually get the stuff      cd "$1"
143  #   $2 - descriptive name      ORIG_CM_DIR_ARC=unknown
144  #   $3 - base name without extension, without version, and without dir      for i in * .[a-zA-Z0-9]* ; do
145  #   $4 - remote directory          if [ -d $i ] ; then
146  #              ORIG_CM_DIR_ARC=$i
 fetchurl() {  
     getter=$1 ; shift  
     echo Fetching $1 from $2. Please stand by...  
     fetched=no  
     for ext in tgz tar.gz tar.Z tz tar tar.bz2 ; do  
         try=$VERSION-$2.$ext  
         echo Trying $try ...  
         if $getter $3 $try $ROOT/$try ; then  
             fetched=yes  
             echo Success.  
147              break              break
         else  
             rm -f $ROOT/$try  
148          fi          fi
149      done      done
150      if [ $fetched = no ] ; then      if [ $ORIG_CM_DIR_ARC = unknown ] ; then
151          echo No success.  You should try to do it manually now.          complain "$this: could not determine CM metadata directory name"
         askurl "$1" "$2" "$3"  
     fi  
 }  
   
 usewget() {  
     wget -nv -O $3 $1/$2  
 }  
   
 uselynx() {  
     lynx -source $1/$2 >$3  
 }  
   
 testurlgetter() {  
     (exec >/dev/null 2>&1 ; exec $*)  
 }  
   
 #  
 # Function to check whether wget or lynx is available.  
 # Set URLGETTER accordingly.  
 #  
 urlgetter() {  
     if [ "$URLGETTER" = unknown ] ; then  
         if testurlgetter wget --help ; then  
             URLGETTER="fetchurl usewget"  
         elif testurlgetter lynx -help ; then  
             URLGETTER="fetchurl uselynx"  
152          else          else
153              URLGETTER="askurl"          echo "$this: CM metadata directory name is \"${ORIG_CM_DIR_ARC}\""
         fi  
154      fi      fi
155  }  }
156    
 #  
 # Function to unpack a source archive.  
 #  
 # $1: descriptive name of the sources to be unpacked  
 # $2: the directory into which to unpack the sources  
 # $3: the sub-directory of $2 that is going to be created by unpacking  
 # $4: the basename of the source archive (the script will check several  
 #     different suffixes to determine what kind of de-compression is to  
 #     be used)  
 #  
 # fetch_n_unpack is the helper function that does the real work.  If  
 # on archive is found locally, it invokes $URLGETTER and tries again.  
 # The variable $tryfetch is used to make sure this happens only once.  
 fetch_n_unpack() {  
     larc=$ROOT/$VERSION-$4  
     cd $2  
     if [ -r $larc.tar.Z ] ; then  
         echo "Un-compress-ing and un-tar-ing $1 archive."  
         zcat $larc.tar.Z | tar -xf -  
     elif [ -r $larc.tar ] ; then  
         echo "Un-tar-ing $1 archive."  
         tar -xf $larc.tar  
     elif [ -r $larc.tar.gz ] ; then  
         echo "Un-gzip-ing and un-tar-ing $1 archive."  
         gunzip -c $larc.tar.gz | tar -xf -  
     elif [ -r $larc.tar.bz2 ] ; then  
         echo "Un-bzip2-ing and un-tar-ing $1 archive."  
         bunzip2 -c $larc.tar.bz2 | tar -xf -  
     elif [ -r $larc.tgz ] ; then  
         echo "Un-gzip-ing and un-tar-ing $1 archive."  
         gunzip -c $larc.tgz | tar -xf -  
     elif [ -r $larc.tz ] ; then  
         echo "Un-compress-ing and un-tar-ing $1 archive."  
         zcat $larc.tz | tar -xf -  
     elif [ $tryfetch = yes ] ; then  
         urlgetter  
         $URLGETTER "$1" $4 $SRCARCHIVEURL  
         tryfetch=no  
         fetch_n_unpack "$1" "$2" "$3" "$4"  
     fi  
 }  
   
 #  
 # The main "unpack" driver function that invokes the above helper.  
 #  
 unpack() {  
     tryfetch=yes  
     if [ -d $2/$3 ]; then  
         echo "The $1 tree already exists."  
     else  
         fetch_n_unpack "$1" "$2" "$3" "$4"  
     fi  
     if [ ! -d $2/$3 ]; then  
         echo "!!! Unable to unpack $1 archive."  
         exit 1  
     fi  
 }  
157    
158  # A function to move all stable library files to a parallel directory  # A function to move all stable library files to a parallel directory
159  # hierarchy.  # hierarchy.
160  # The first argument must be a simple path (no / inside), and  # The first argument must be a simple path (no / inside), and
161  # the second argument must be an absolute path.  # the second argument must be an absolute path.
162  move() {  move() {
163      if [ -d $1 ] ; then      if [ -L "$1" ] ; then
164          if [ ! -d $2 ] ; then          rm -f "$1"           # remove symbolic link made by diracs (see below)
165              if [ -f $2 ] ; then      elif [ -d "$1" ] ; then
166                  echo install.sh: $2 exists as a non-directory.          if [ ! -d "$2" ] ; then
167                  exit 1              if [ -f "$2" ] ; then
168              fi                  complain $this: $2 exists as a non-directory.
169              mkdir $2              fi
170          fi              mkdir "$2"
171          cd $1          fi
172          for i in * ; do          cd "$1"
173              move $i $2/$i          for i in * .[a-zA-Z0-9]* ; do
174                move "$i" "$2"/"$i"
175          done          done
176          cd ..          cd ..
177      elif [ -f $1 ] ; then      elif [ -f "$1" ] ; then
178          rm -f $2          rm -f "$2"
179          mv $1 $2          mv "$1" "$2"
180      fi      fi
181  }  }
182    
183  #  #
184  # Move the stable archive of a library whose description file was $1/$2 to  # Traverse the directory tree rooted at $3 (must be single arc!).
185  # $LIBDIR/$2/CM/$ARCH-unix/$2 so that it appears as if the description file  # Find all directories named $1, rename them into $2 and make
186  # had been at $LIBDIR/$2/$2  # and establish $1 as a symbolic link to $2:
 #  
 # (This script will also move all other libraries that show up in  
 #  $1/CM/$ARCH-unix because in the case of the boot directory this indicates  
 #  that some library did not have its own path anchor but was specified  
 #  relative to $1/$2. Still, don't rely on this to be robust -- rather make  
 #  separate anchors for every library!)  
 #  
 movelibs() {  
     for lib in `/bin/ls $1/CM/$ARCH-unix` ; do  
         case $lib in  
         *.cm | *.cmi)  
             if [ $lib != $2 ] ; then  
                 echo "! Warning:" $lib specified relative to $2  
             fi  
             echo Moving library $lib to $LIBDIR  
             makedir $LIBDIR/$2  
             makedir $LIBDIR/$2/CM  
             makedir $LIBDIR/$2/CM/$ARCH-unix  
             mv $1/CM/$ARCH-unix/$lib $LIBDIR/$2/CM/$ARCH-unix/$lib  
             ;;  
         *)  
             ;;  
         esac  
      done  
 }  
   
 # A shell function that registers a library for being built.  
 # This function takes two arguments: 1. a name under which the library  
 # is to be known later (something.cm) and 2. the path relative to $SRCDIR  
 # that leads to the library's .cm file.  The library's .cm file must be the  
 # same as $1.  
 #  
 # This works by adding ML code to file $LIBLIST.  The code in this file  
 # will be executed near the end of this script.  If $MOVE_LIBRARIES is  
 # set to true, then reglib will also register a "movelibs" to be executed at  
 # the end by putting a "movelibs" line into $LIBMOVESCRIPT.  
   
 reglib() {  
     if [ x$MOVE_LIBRARIES = xtrue ] ; then  
         FINALLOCATION=$LIBDIR/$1  
     else  
         FINALLOCATION=$SRCDIR/$2  
     fi  
     if [ -d $FINALLOCATION/CM/$ARCH-unix ] ; then  
         echo "Library $1 already exists in $FINALLOCATION."  
     else  
         echo "Scheduling library $1 to be built in $FINALLOCATION."  
         echo "andalso CM.stabilize false \"$1\"" >>$LIBLIST  
         echo $1 $SRCDIR/$2 >>$LOCALPATHCONFIG  
         if [ x$MOVE_LIBRARIES = xtrue ] ; then  
             echo movelibs $SRCDIR/$2 $1 >>$LIBMOVESCRIPT  
         fi  
         echo $1 $FINALLOCATION >>$CM_PATHCONFIG_DEFAULT  
     fi  
 }  
   
187  #  #
188  # Function to build a standalone program such as ml-yacc.  The function takes  dirarcs() {
189  # 2 or 3 arguments.  First the name of the program which at the same time      if [ -d "$3" ] ; then
190  # is the directory name under $SRCDIR where the sources reside.  The second          if [ "$3" = "$1" ] ; then
191  # argument is a descriptive name for the program (passed on to "unpack").              mv "$1" "$2"
192  # The optional third argument specifies the path relative to $SRCDIR/$1              ln -s "$2" "$1"
 # of the directory where the program's heap image is to be found.  
 #  
   
 standalone() {  
     TARGET=$1.$HEAP_SUFFIX  
     if [ $# = 3 ] ; then  
         TARGETLOC=$3/$TARGET  
     else  
         TARGETLOC=$TARGET  
     fi  
     if [ -r $HEAPDIR/$TARGET ] ; then  
         echo Target $TARGET already exists.  
     else  
         echo Building $TARGET.  
         unpack $2 $SRCDIR $1 $1  
         cd $SRCDIR/$1  
         ./build  
         if [ -r $TARGETLOC ] ; then  
             mv $TARGETLOC $HEAPDIR/$TARGET  
             if [ ! -f $BINDIR/$1 ] ; then  
                 cd $BINDIR  
                 ln -s .run-sml $1  
             fi  
193          else          else
194              echo "!!! Build of $TARGET failed."              cd "$3"
195                for d in * .[a-zA-Z0-9]* ; do
196                    dirarcs "$1" "$2" "$d"
197                done
198                cd ..
199          fi          fi
200      fi      fi
201  }  }
202    
203    
204    ######################################################################
205    
206  #  #
207  # create the various sub directories  # create the various sub directories
208  #  #
209  for dir in $BINDIR $HEAPDIR $RUNDIR $LIBDIR $SRCDIR  for dir in "$BINDIR" "$HEAPDIR" "$RUNDIR" "$LIBDIR" "$SRCDIR" ; do
210  do      makedir "$dir"
     makedir $dir  
211  done  done
212    
213  #  #
 # install the script that tests the architecture, and make sure that it works  
 #  
 if [ -x $BINDIR/.arch-n-opsys ]; then  
     echo Script $BINDIR/.arch-n-opsys already exists.  
 else  
     cat $CONFIGDIR/_arch-n-opsys \  
     | sed -e "s,@SHELL@,$SHELL,g" > $BINDIR/.arch-n-opsys  
     chmod 555 $BINDIR/.arch-n-opsys  
     if [ ! -x $BINDIR/.arch-n-opsys ]; then  
         echo "!!! Installation of $BINDIR/.arch-n-opsys failed."  
         exit 1  
     fi  
 fi  
   
 ARCH_N_OPSYS=`$BINDIR/.arch-n-opsys`  
 if [ "$?" != "0" ]; then  
     echo "!!! Script $BINDIR/.arch-n-opsys fails on this machine."  
     echo "!!! You must patch this by hand and repeat the installation."  
     exit 2  
 else  
     echo Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.  
 fi  
 eval $ARCH_N_OPSYS  
   
 #  
214  # Function to install a "driver" script...  # Function to install a "driver" script...
215  #   This takes care of patching the source of the script with the SHELL,  #   This takes care of patching the source of the script with the SHELL,
216  #   BINDIR, and VERSION variables to use.  #   BINDIR, and VERSION variables to use.
# Line 404  Line 222 
222  # for an outdated driver script, but not all "test" commands understand  # for an outdated driver script, but not all "test" commands understand
223  # the -nt comparison operator....)  # the -nt comparison operator....)
224  #   if [ -x $BINDIR/$ddst ]; then  #   if [ -x $BINDIR/$ddst ]; then
225  #       echo Script $BINDIR/$ddst already exists.  #       echo $this: Script $BINDIR/$ddst already exists.
226  #   else  #   else
227          rm -f $BINDIR/$ddst          rm -f "$BINDIR"/"$ddst"
228          cat $CONFIGDIR/$dsrc | \          cat "$CONFIGDIR"/"$dsrc" | \
229          sed -e "s,@SHELL@,$SHELL,g" \          sed -e "s,@SHELL@,$SHELL,g" \
230              -e "s,@BINDIR@,$BINDIR," \              -e "s,@BINDIR@,$BINDIR," \
231              -e "s,@VERSION@,$VERSION," \              -e "s,@VERSION@,$VERSION," \
232              > $BINDIR/$ddst              -e "s,@CMDIRARC@,${CM_DIR_ARC:-dummy}," \
233          chmod 555 $BINDIR/$ddst              > "$BINDIR"/"$ddst"
234          if [ ! -x $BINDIR/$ddst ]; then          chmod 555 "$BINDIR"/"$ddst"
235              echo "!!! Installation of $BINDIR/${ddst} failed."          if [ ! -x "$BINDIR"/"$ddst" ]; then
236              exit 1              complain "$this: !!! Installation of $BINDIR/${ddst} failed."
237          fi          fi
238  #   fi  #   fi
239  }  }
240    
241    #
242    # install the script that tests architecture and os...
243    #
244    installdriver _arch-n-opsys .arch-n-opsys
245    
246    #
247    # run it to figure out what architecture and os we are using, define
248    # corresponding variables...
249    #
250    ARCH_N_OPSYS=`"$BINDIR"/.arch-n-opsys`
251    if [ "$?" != "0" ]; then
252        echo "$this: !!! Script $BINDIR/.arch-n-opsys fails on this machine."
253        echo "$this: !!! You must patch this by hand and repeat the installation."
254        exit 2
255    else
256        vsay $this: Script $BINDIR/.arch-n-opsys reports $ARCH_N_OPSYS.
257    fi
258    eval $ARCH_N_OPSYS
259    
260    #
261    # now install most of the other driver scripts
262    #  (except ml-build, since we don't know $CM_DIR_ARC yet)
263    #
264  installdriver _run-sml .run-sml  installdriver _run-sml .run-sml
265  installdriver _link-sml .link-sml  installdriver _link-sml .link-sml
266  installdriver _ml-build ml-build  installdriver _ml-makedepend ml-makedepend
267    
268    installdriver _heap2exec heap2exec
269    
270  #  #
271  # set some architecture dependent run-time system flags  # set some architecture dependent run-time system flags
# Line 432  Line 275 
275          ALLOC=1M          ALLOC=1M
276          ;;          ;;
277      x86)      x86)
278            # The following is the _wrong_ value for many popular x86 chips
279            # (i.e., Celerons).  However, the optimal value for those is 32k,
280            # and such a small value is not enough for the runtime system's boot
281            # code.  Therefore, we use 256k here and re-set it to the proper
282            # value in .run-sml.
283          ALLOC=256k          ALLOC=256k
284          ;;          ;;
285      alpha32)      alpha32)
# Line 449  Line 297 
297      linux)      linux)
298          EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`          EXTRA_DEFS=`$CONFIGDIR/chk-global-names.sh`
299          if [ "$?" != "0" ]; then          if [ "$?" != "0" ]; then
300              echo "!!! Problems checking for underscores in global names."              complain "$this: !!! Problems checking for underscores in asm names."
             exit 1  
301          fi          fi
302          EXTRA_DEFS="XDEFS=$EXTRA_DEFS"          EXTRA_DEFS="XDEFS=$EXTRA_DEFS"
303          ;;          ;;
# Line 459  Line 306 
306  #  #
307  # the name of the bin files directory  # the name of the bin files directory
308  #  #
309  BOOT_FILES=sml.boot.$ARCH-unix  BOOT_ARCHIVE=boot.$ARCH-unix
310    BOOT_FILES=sml.$BOOT_ARCHIVE
311    
312  #  #
313  # build the run-time system  # build the run-time system
314  #  #
315  unpack "run-time" $SRCDIR runtime runtime  if [ -x "$RUNDIR"/run.$ARCH-$OPSYS ]; then
316  if [ -x $RUNDIR/run.$ARCH-$OPSYS ]; then      vsay $this: Run-time system already exists.
     echo Run-time system already exists.  
317  else  else
318      cd $SRCDIR/runtime/objs      "$CONFIGDIR"/unpack "$ROOT" runtime
319      echo Compiling the run-time system.      cd "$SRCDIR"/runtime/objs
320        echo $this: Compiling the run-time system.
321      $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS      $MAKE -f mk.$ARCH-$OPSYS $EXTRA_DEFS
322      if [ -x run.$ARCH-$OPSYS ]; then      if [ -x run.$ARCH-$OPSYS ]; then
323          mv run.$ARCH-$OPSYS $RUNDIR          mv run.$ARCH-$OPSYS "$RUNDIR"
324          # $MAKE MAKE=$MAKE clean          if [ -f runx.$ARCH-$OPSYS ]; then
325                mv runx.$ARCH-$OPSYS "$RUNDIR"
326            fi
327            $MAKE MAKE=$MAKE clean
328      else      else
329          echo "!!! Run-time system build failed for some reason."          complain "$this: !!! Run-time system build failed for some reason."
         exit 1  
330      fi      fi
331  fi  fi
332  cd $SRCDIR  cd "$SRCDIR"
333    
334  #  #
335  # boot the base SML system  # boot the base SML system
336  #  #
337  if [ -r $HEAPDIR/sml.$HEAP_SUFFIX ]; then  if [ -r "$HEAPDIR"/sml.$HEAP_SUFFIX ]; then
338      echo Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.      vsay $this: Heap image $HEAPDIR/sml.$HEAP_SUFFIX already exists.
339        fish "$LIBDIR"/smlnj/basis
340        # ignore requested arc name since we have to live with what is there:
341        export CM_DIR_ARC
342        CM_DIR_ARC=$ORIG_CM_DIR_ARC
343        # now re-dump the heap image:
344        vsay "$this: Re-creating a (customized) heap image..."
345        "$BINDIR"/sml @CMredump "$ROOT"/sml
346        cd "$ROOT"
347        if [ -r sml.$HEAP_SUFFIX ]; then
348            mv sml.$HEAP_SUFFIX "$HEAPDIR"
349        else
350            complain "$this !!! Unable to re-create heap image (sml.$HEAP_SUFFIX)."
351        fi
352  else  else
353      unpack bin $ROOT $BOOT_FILES $BOOT_FILES      "$CONFIGDIR"/unpack "$ROOT" "$BOOT_ARCHIVE"
354      cd $ROOT/$BOOT_FILES  
355      if $BINDIR/.link-sml @SMLheap=$ROOT/sml @SMLboot=BOOTLIST @SMLalloc=$ALLOC      fish "$ROOT"/"$BOOT_FILES"/smlnj/basis
356    
357        cd "$ROOT"
358    
359        # Target arc:
360        export CM_DIR_ARC
361        CM_DIR_ARC=${CM_DIR_ARC:-".cm"}
362    
363        if [ $CM_DIR_ARC = $ORIG_CM_DIR_ARC ] ; then
364            : we are happy
365        else
366            # now we have to make a symbolic link for each occurrence of
367            # $ORIG_CM_DIR_ARC to $CM_DIR_ARC
368            dirarcs "$ORIG_CM_DIR_ARC" "$CM_DIR_ARC" "$BOOT_FILES"
369        fi
370    
371        cd "$ROOT"/"$BOOT_FILES"
372    
373        # now link (boot) the system and let it initialize itself...
374        if "$BINDIR"/.link-sml @SMLheap="$ROOT"/sml @SMLboot=BOOTLIST @SMLalloc=$ALLOC
375      then      then
376          cd $ROOT          cd "$ROOT"
377          if [ -r sml.$HEAP_SUFFIX ]; then          if [ -r sml.$HEAP_SUFFIX ]; then
378              mv sml.$HEAP_SUFFIX $HEAPDIR              mv sml.$HEAP_SUFFIX "$HEAPDIR"
379              cd $BINDIR              cd "$BINDIR"
380              ln -s .run-sml sml              ln -s .run-sml sml
381              #              #
382              # Now move all stable libraries to #LIBDIR and generate              # Now move all stable libraries to #LIBDIR and generate
383              # the pathconfig file.              # the pathconfig file.
384              #              #
385              cd $ROOT/$BOOT_FILES              cd "$ROOT"/"$BOOT_FILES"
386              for anchor in * ; do              for anchor in * ; do
387                  if [ -d $anchor ] ; then                  if [ -d $anchor ] ; then
388                      echo $anchor $anchor >>$CM_PATHCONFIG_DEFAULT                      echo $anchor $anchor >>$CM_PATHCONFIG
389                      move $anchor $LIBDIR/$anchor                      move $anchor "$LIBDIR"/$anchor
390                  fi                  fi
391              done              done
392              cd $ROOT              cd "$ROOT"
393              # $BOOT_FILES is now only an empty skeleton, let's get rid of it.              # $BOOT_FILES is now only an empty skeleton, let's get rid of it.
394              rm -rf $BOOT_FILES              rm -rf "$BOOT_FILES"
395    
396          else          else
397              echo "!!! Boot code did not produce heap image (sml.$HEAP_SUFFIX)."              complain "$this !!! No heap image generated (sml.$HEAP_SUFFIX)."
             exit 1  
398          fi          fi
399      else      else
400          echo "!!! Boot code failed, no heap image built (sml.$HEAP_SUFFIX)."          complain "$this !!! Boot code failed, no heap image (sml.$HEAP_SUFFIX)."
         exit 1  
401      fi      fi
402  fi  fi
403    
404  #  #
405  # Initialize $LIBLIST  # now that we know CM_DIR_ARC we can install the ml-build driver...
406  #  #
407  cd $ROOT  installdriver _ml-build ml-build
 rm -f $LOCALPATHCONFIG $LIBLIST  
 echo 'OS.Process.exit (if true' >$LIBLIST  
   
 #  
 # now build (or prepare to build) the individual targets  
 #  
 cd $SRCDIR  
 echo Installing other targets.  
 for i in $TARGETS ; do  
     case $i in  
       src-smlnj)  
         for src in compiler cm MLRISC smlnj-lib ml-yacc system  
         do  
             unpack $src $ROOT/src $src $src  
         done  
         ;;  
       ml-yacc)  
         standalone ml-yacc ML-Yacc src  
         echo ml-yacc $TOOLDIR >>$CM_PATHCONFIG_DEFAULT  
         ;;  
       ml-lex)  
         standalone ml-lex ML-Lex  
         echo ml-lex $TOOLDIR >>$CM_PATHCONFIG_DEFAULT  
         ;;  
       ml-burg)  
         standalone ml-burg ML-Burg  
         echo ml-burg $TOOLDIR >>$CM_PATHCONFIG_DEFAULT  
         ;;  
       smlnj-lib)  
         unpack "SML/NJ Library" $SRCDIR smlnj-lib smlnj-lib  
408    
409          # Don't make the Util library -- it came pre-made and has been  cd "$ROOT"
         # installed when making the base system.  In other words, don't do...  
             #reglib smlnj-lib.cm smlnj-lib/Util  
         # ... and don't make the HTML library ...  
             #reglib html-lib.cm smlnj-lib/HTML  
         # ... and don't make the PP library ...  
             #reglib pp-lib.cm smlnj-lib/PP  
         # make the Unix library  
             reglib unix-lib.cm smlnj-lib/Unix  
         # make the INet library  
             reglib inet-lib.cm smlnj-lib/INet  
         # make the RegExp library  
             reglib regexp-lib.cm smlnj-lib/RegExp  
         # make the Reactive library  
             reglib reactive-lib.cm smlnj-lib/Reactive  
         ;;  
       cml)  
         unpack CML $SRCDIR cml cml  
         reglib core-cml.cm cml/src/core-cml  
         reglib cml.cm cml/src  
         reglib cml-basis.cm cml  
         ;;  
       cml-lib)  
         unpack CML $SRCDIR cml cml  
         reglib cml-lib.cm cml/cml-lib  
         ;;  
       eXene)  
         unpack EXene $SRCDIR eXene eXene  
         reglib eXene.cm eXene  
         ;;  
       doc)  
         unpack Doc $ROOT doc doc  
         cd $ROOT/doc  
         build $ROOT  
         ;;  
       *)  
         echo "!!! Unknown target $i."  
         ;;  
     esac  
 done  
410    
411  #  #
412  # Now go and stabilize all registered libraries...  # Now do all the rest using the precompiled installer:
 # This is done with library sources in their original locations inside  
 # $SRCDIR, so we must consult $LOCALPATHCONFIG.  
413  #  #
414    if [ $nolib = false ] ; then
415  echo Compiling library code.      echo $this: Installing other libraries and programs:
416  echo 'then OS.Process.success else OS.Process.failure);' >>$LIBLIST      export ROOT INSTALLDIR CONFIGDIR BINDIR
417  if CM_LOCAL_PATHCONFIG=$LOCALPATHCONFIG $BINDIR/sml <$LIBLIST ; then      if "$BINDIR"/sml -m \$smlnj/installer.cm
418      echo Libraries compiled successfully.      then
419            vsay $this: Installation complete.
420  else  else
421      echo "!!! Something went wrong when compiling the libraries."          complain "$this: !!! Installation of libraries and programs failed."
     exit 1  
422  fi  fi
   
 #  
 # Finally, move the libraries to their final locations...  
 #  
   
 if [ -r $LIBMOVESCRIPT ] ; then  
     echo Moving libraries to $LIBDIR.  
     . $LIBMOVESCRIPT  
423  fi  fi
424    
425  exit 0  exit 0

Legend:
Removed from v.573  
changed lines
  Added in v.1873

root@smlnj-gforge.cs.uchicago.edu
ViewVC Help
Powered by ViewVC 1.0.0